#!/bin/bash
#
# Acquire buffer 2, also being the destination for U3 to U5 commands
# 0x0500 for 1541 and compatibles, 0x1300 for 2040 and compatibles
#

ADAPTER=xum1541:40
DRIVEID=09
DUMPFILE=CMD-Floppy-FDC-Memdump-ID-"${DRIVEID}"-`date +%Y%m%d-%H%M%S`.bin


cbmctrl -@${ADAPTER} open ${DRIVEID} 15 ""



# Setzen des Bufferpointers auf Puffer 2, Zielpuffer fr Ux-Befehle
cbmctrl -@${ADAPTER} open ${DRIVEID} 2 "#2"

cbmctrl -@${ADAPTER} listen ${DRIVEID} 15
cbmctrl -@${ADAPTER} put "B-P 2 0"
cbmctrl -@${ADAPTER} unlisten

# Upload der Routine zum Auslesen von Speicherbereichen

cbmctrl -@${ADAPTER} listen ${DRIVEID} 2

base64 -d << EOF | cbmctrl -@${ADAPTER} write
TDwHOOkMqsqtAkPgBhAarQICjSAFqQSNIwUIeKIAvQD/nQ
AE6ND3KGCNIBOOIxPQ6anQjQUQrQUQMPtgIBoHqQFsAvw=
EOF

cbmctrl -@${ADAPTER} unlisten

cbmctrl -@${ADAPTER} close ${DRIVEID} 2


# Setzen des Bufferpointers auf Puffer 1, Zwischenspeicher fr kopierte Bereiche
cbmctrl -@${ADAPTER} open ${DRIVEID} 2 "#1"


# In einer Schleife 256 Blcke durchzhlen und transferieren

rm -f "${DUMPFILE}"
for (( i=0; i<256 ;i++ ))
do
	echo "Hole FDC-Speicherbereich: $i"
	cbmctrl -@${ADAPTER} listen ${DRIVEID} 15
	cbmctrl -@${ADAPTER} put "U4" ${i}
	cbmctrl -@${ADAPTER} unlisten

	cbmctrl -@${ADAPTER} listen ${DRIVEID} 15
	cbmctrl -@${ADAPTER} put "B-P 2 0"
	cbmctrl -@${ADAPTER} unlisten

	cbmctrl -@${ADAPTER} talk ${DRIVEID} 2
	cbmctrl -@${ADAPTER} read 2>/dev/null | dd bs=256 count=1 2>/dev/null | tee -a "${DUMPFILE}" | xxd
	cbmctrl -@${ADAPTER} untalk
done

cbmctrl -@${ADAPTER} close ${DRIVEID} 2
cbmctrl -@${ADAPTER} close ${DRIVEID} 15
